--Best = 

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local file = require('scenario/fileHandler')


local function onRaceStart()
	if not start then start = true end
end

local function success(score)
	local medal, nextMedal
	if score < 100 then 
		medal = 'None'
		nextMedal = 'Bronze(100)'
	elseif score >= 100 and score < 150 then 
		medal = 'Bronze'
		nextMedal = 'Silver(170)'
	elseif score >= 150 and score < 170 then 
		medal = 'Silver'
		nextMedal = 'Gold(190)'
	elseif score >= 190 and score < 210 then 
		medal = 'Gold'
		nextMedal = 'Platinum(210)'
	elseif score >= 210 and score < 250 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(250)'
	elseif score >= 250 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 4, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	scoreFinal = math.floor(scoreFinal+(60-scenarioTime))
	success(scoreFinal)
end

local function onBeamNGTrigger(data)
	if data.event == 'enter' and data.triggerName ~= 'finish' then
		local targetScore = tonumber(string.match(data.triggerName, '%d+'))
		scoreFinal = scoreFinal+targetScore
	elseif data.triggerName == 'finish' then finish()
	end
end

local function onRaceTick(raceTickTime) scenarioTime = scenarioTime+raceTickTime end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
return M